<template>
   <b-container>
    <h5 class="text-second mb-3 mt-3"><b-icon icon="circle-square"></b-icon> &nbsp; Remplissage</h5>
    <b-row class="mb-3">
            <b-col cols="4">
                <label class="col-form-label">Motif </label>
            </b-col>
            <b-col cols="8">
                <b-select value-field="item"
                text-field="name" v-on:change="onChangeType($event)"
                :value="fillPattern" :options="motifList"></b-select>
            </b-col>

    </b-row>
    <FormTextInput v-if="fillStyle.fillPattern!='none'" v-bind:label="'Couleur de remplissage'" :colorPicker="true"
      @inputChange="inputChange()"
      v-model="fillStyle.fillColor" :placeholder="fillStyle.baseStyle.fillColor"/>

    <SymbolStyleDefinition v-if="hasMotif"
      :symbol="fillStyle.fillSymbol"
      :type="fillStyle.fillPattern"/>

    <FormTextInput v-if="hasMotif"
      @inputChange="inputChange()"
      v-bind:label="'Espacement entre les symboles'"
      v-model="fillStyle.fillPatternMargin" :placeholder="fillStyle.baseStyle.fillPatternMargin"/>
   </b-container>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Vue from 'vue';
import SymbolStyleDefinition from '@/components/layers/style/SymbolStyleDefinition.vue';
import FormTextInput from '@/components/shared/FormTextInput.vue';
import FillStyle from '@/models/map-context/style/FillStyle';
import Component from 'vue-class-component';

@Component({
  props: {
    fillStyle: FillStyle,
  },
  components: {
    SymbolStyleDefinition,
    FormTextInput,
  },
})
export default class FillStyleDefinition extends Vue {
  fillStyle!:FillStyle;

  motifList=[{ item: 'simple', name: 'Remplissage simple' },
    { item: 'none', name: 'Pas de remplissage' },
    { item: 'svg', name: 'symboles SVG' },
    { item: 'circle', name: 'cercles' },
    { item: 'square', name: 'carrés' },
    { item: 'slash', name: 'hachure' },
    { item: 'backslash', name: 'hachure (2)' },
    { item: 'cross', name: 'croix' },
    { item: 'plus', name: 'plus' },
    { item: 'horline', name: 'Lignes horizontales' },
    { item: 'vertline', name: 'Lignes verticales' },
    { item: 'dot', name: 'points' }];

  get hasMotif() {
    return this.fillStyle.fillPattern !== undefined
    && this.fillStyle.fillPattern !== ''
    && this.fillStyle.fillPattern !== 'none'
    && this.fillStyle.fillPattern !== 'simple';
  }

  get fillPattern() {
    console.log(this.fillStyle.getFillPattern());
    return this.fillStyle.getFillPattern();
  }

  onChangeType(event:any) {
    this.fillStyle.fillPattern = event;
    this.inputChange();
  }

  inputChange() {
    this.$emit('symboChange', '');
  }
}
</script>

<style scoped lang="less">

</style>
